// package com.jnssd.config;
//
// import io.swagger.annotations.ApiOperation;
// import org.springframework.context.annotation.Bean;
// import org.springframework.context.annotation.Configuration;
// import springfox.documentation.builders.ApiInfoBuilder;
// import springfox.documentation.builders.OAuthBuilder;
// import springfox.documentation.builders.PathSelectors;
// import springfox.documentation.builders.RequestHandlerSelectors;
// import springfox.documentation.oas.annotations.EnableOpenApi;
// import springfox.documentation.service.*;
// import springfox.documentation.spi.DocumentationType;
// import springfox.documentation.spi.service.contexts.SecurityContext;
// import springfox.documentation.spring.web.plugins.Docket;
// import springfox.documentation.swagger.web.ApiKeyVehicle;
// import springfox.documentation.swagger.web.SecurityConfiguration;
// import springfox.documentation.swagger.web.SecurityConfigurationBuilder;
// import springfox.documentation.swagger2.annotations.EnableSwagger2;
//
// import java.util.ArrayList;
// import java.util.Collections;
// import java.util.List;
//
// /**
//  * <h3>spring-boot-openapi</h3>
//  * <p></p>
//  *
//  * @author zxj
//  * @since 2023-10-12 17:13:09
//  */
// @Configuration
// @EnableSwagger2
// @EnableOpenApi
// public class SwaggerConfig {
//
//     @Bean
//     public Docket api() {
//         return new Docket(DocumentationType.SWAGGER_2)
//                 .apiInfo(apiInfo())
//                 .select()
//                 // 扫描特定包
//                 // 扫描所有有注解的api，用这种方式更灵活
//                 // .apis(RequestHandlerSelectors.withMethodAnnotation(ApiOperation.class))
//                 //.apis(RequestHandlerSelectors.any())
//                 .apis(RequestHandlerSelectors.basePackage("com.jnssd"))
//                 .paths(PathSelectors.any())
//                 .build()
//                 .securitySchemes(initSecuritySchemeList())
//                 .securityContexts(Collections.singletonList(securityContext()));
//     }
//     public ApiInfo apiInfo() {
//         return new ApiInfoBuilder()
//                 .title("Swagger项目测试")
//                 .description("novel项目接口文档")
//                 .build();
//     }
//
//     private SecurityContext securityContext() {
//         return SecurityContext.builder()
//                 .securityReferences(Collections.singletonList(new SecurityReference("OAuth2", new AuthorizationScope[0])))
//                 .build();
//     }
//
//     private List<AuthorizationScope> scopes() {
//         List<AuthorizationScope> list = new ArrayList<>();
//         list.add(new AuthorizationScope("read_scope", "Grants read access"));
//         list.add(new AuthorizationScope("write_scope", "Grants write access"));
//         list.add(new AuthorizationScope("admin_scope", "Grants read write and delete access"));
//         return list;
//     }
//
//     public List<SecurityScheme> initSecuritySchemeList() {
//         List<SecurityScheme> list = new ArrayList<>();
//         list.add(securitySchemeOAuth2());
//         list.add(securitySchemeApiKey());
//         // list.add(securitySchemeHttp());
//         list.add(securitySchemeBasicAuth());
//         list.add(securitySchemeOauth2Schema());
//         return list;
//     }
//
//     private SecurityScheme securitySchemeOAuth2() {
//         List<GrantType> grantTypes = new ArrayList<>();
//         grantTypes.add(new ResourceOwnerPasswordCredentialsGrant("/oauth/token"));
//         return new OAuthBuilder()
//                 .name("OAuth2")
//                 .scopes(scopes())
//                 .grantTypes(grantTypes)
//                 .build();
//     }
//
//     private SecurityScheme securitySchemeApiKey() {
//         return new ApiKey("Authorization", "api_key", ApiKeyVehicle.HEADER.getValue());
//     }
//
//     private SecurityScheme securitySchemeHttp() {
//         return HttpAuthenticationScheme.JWT_BEARER_BUILDER.name("JWT").build();
//     }
//
//     private SecurityScheme securitySchemeBasicAuth() {
//         return new BasicAuth("basicAuth");
//     }
//
//     private SecurityScheme securitySchemeOauth2Schema() {
//         List<GrantType> grantTypes = new ArrayList<>();
//         TokenRequestEndpoint tokenRequestEndpoint = new TokenRequestEndpoint("/oauth/authorize", "", "");
//         TokenEndpoint tokenEndpoint = new TokenEndpoint("/oauth/token", "token");
//         grantTypes.add(new AuthorizationCodeGrant(tokenRequestEndpoint, tokenEndpoint));
//         return new OAuthBuilder()
//                 .name("oauth2schema")
//                 .scopes(scopes())
//                 .grantTypes(grantTypes)
//                 .build();
//     }
//
//     @Bean
//     public SecurityConfiguration security() {
//         return SecurityConfigurationBuilder.builder()
//                 .clientId("")
//                 .clientSecret("")
//                 .realm("*")
//                 .appName("")
//                 .scopeSeparator("")
//                 .useBasicAuthenticationWithAccessCodeGrant(false)
//                 .build();
//     }
//
// }
